;========================================================================
;Section IVT
;========================================================================

cpu 80186

section ivt start=0 ; you will need this later

idt:
   dw diverr_handler, (section.code.start >> 4)
   dw brk_handler, (section.code.start >> 4)
   dw nmi_handler, (section.code.start >> 4)
   dw int3_handler, (section.code.start >> 4)
   dw into_handler, (section.code.start >> 4)
   dw bound_handler, (section.code.start >> 4)
   dw undefinst_handler, (section.code.start >> 4)
   dw nocoprocessor_handler, (section.code.start >> 4)
   dw vbl_handler, (section.code.start >> 4)
   dw sprbuf_handler, (section.code.start >> 4)
   dw raster_handler, (section.code.start >> 4)
   dw sound_handler, (section.code.start >> 4)
   dw def_handler, (section.code.start >> 4)
   dw def_handler, (section.code.start >> 4)
   dw def_handler, (section.code.start >> 4)
   dw def_handler, (section.code.start >> 4)
   dw coprocessorerror_handler, (section.code.start >> 4)
   dw def_handler, (section.code.start >> 4)
   dw def_handler, (section.code.start >> 4)
   dw def_handler, (section.code.start >> 4)
   dw def_handler, (section.code.start >> 4)
   dw def_handler, (section.code.start >> 4)
   dw def_handler, (section.code.start >> 4)
   dw def_handler, (section.code.start >> 4)
   dw def_handler, (section.code.start >> 4)
   dw def_handler, (section.code.start >> 4)
   dw def_handler, (section.code.start >> 4)
   dw def_handler, (section.code.start >> 4)
   dw def_handler, (section.code.start >> 4)
   dw def_handler, (section.code.start >> 4)
   dw def_handler, (section.code.start >> 4)
   dw def_handler, (section.code.start >> 4)
   dw vbl_handler, (section.code.start >> 4)
   dw sprbuf_handler, (section.code.start >> 4)
   dw raster_handler, (section.code.start >> 4)
   dw sound_handler, (section.code.start >> 4)

;========================================================================
;Section Code (Pointers)
;========================================================================

section code vstart=0 align=16

diverr_handler:
  iret

brk_handler:
  iret

nmi_handler:
  iret

int3_handler:
  iret

into_handler:
  iret

bound_handler:
  iret

undefinst_handler:
  iret

nocoprocessor_handler:
  iret

vbl_handler:
  iret

sprbuf_handler:
  iret

raster_handler:
  iret

sound_handler:
  iret

def_handler:
  iret

coprocessorerror_handler:
  iret

;========================================================================
;Section Code (Main Code)
;========================================================================

main_code:
  mov DX, WorkRamStart
  mov DS, DX

  mov word [XDirection], 0x0001
  mov word [YDirection], 0x0001
  mov word [XPosition],  0x0000
  mov word [YPosition],  0x0000

  mov DX, VideoHardwareRamStart

;Palette Upload
  mov SI, (section.data.start >> 4)
  mov DS, SI
  mov SI, palette

  mov DI, VideoHardwareRamStart
  mov ES, DI
  mov DI, PaletteRam

  mov CX, 16
  cld
  rep movsw

  mov DX, WorkRamStart
  mov DS, DX

  mov ax, 0x00
  out 0x98, ax

  sti			;Enable Interupts


infinite_loop:

  hlt
  jmp infinite_loop

;========================================================================
;Section Data
;========================================================================

section data vstart=0 align=16

palette:
  dw 0x0000, 0x1111, 0x2222, 0x3333
  dw 0x4444, 0x5555, 0x6666, 0x7777
  dw 0x8888, 0x9999, 0xAAAA, 0xBBBB
  dw 0xCCCC, 0xDDDD, 0xEEEE, 0xFFFF

;========================================================================
;Section Reset
;========================================================================

section reset start=0x7FFF0 vstart=0

  cli
  jmp (section.code.start >> 4):main_code
  
  times 16-($-$$) db 0

;========================================================================
;Section RAM
;========================================================================

segment bss start=0xE0000 vstart=0 nobits align=16

;Define Stuff:
  XDirection			resb 2
  YDirection			resb 2
  XPosition			resb 2
  YPosition			resb 2

  WorkRamStart			equ 0xE000
  VideoHardwareRamStart		equ 0xF000

  SpriteRam			equ 0x8000
  PaletteRam			equ 0x8800
  SpriteControlRam		equ 0x9000

  ScreenWidth 			equ 320
  ScreenHieght 			equ 240
  BallDiameter 			equ 8
  BallVelocity 			equ 2